Index: uspace/lib/posix/stdlib/strtol.c
===================================================================
--- uspace/lib/posix/stdlib/strtol.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/stdlib/strtol.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Backend for integer conversions.
  */
 
@@ -38,10 +38,19 @@
 #include "../stdlib.h"
 
-#include "../limits.h"
 #include "../ctype.h"
 #include "../errno.h"
-
-// TODO: documentation
-
+#include "../inttypes.h"
+#include "../limits.h"
+
+#define intmax_t posix_intmax_t
+#define uintmax_t posix_uintmax_t
+
+/**
+ * Decides whether a digit belongs to a particular base.
+ *
+ * @param c Character representation of the digit.
+ * @param base Base against which the digit shall be tested.
+ * @return True if the digit belongs to the base, false otherwise.
+ */
 static inline bool is_digit_in_base(int c, int base)
 {
@@ -54,5 +63,11 @@
 }
 
-static inline int get_digit_in_base(int c, int base)
+/**
+ * Derive a digit from its character representation.
+ *
+ * @param c Character representation of the digit.
+ * @return Digit value represented by an integer.
+ */
+static inline int digit_value(int c)
 {
 	if (c <= '9') {
@@ -63,7 +78,30 @@
 }
 
-static inline unsigned long long internal_strtol(
+/**
+ * Generic function for parsing an integer from it's string representation.
+ * Different variants differ in lower and upper bounds.
+ * The parsed string returned by this function is always positive, sign
+ * information is provided via a dedicated parameter.
+ *
+ * @param nptr Input string.
+ * @param endptr If non-NULL, *endptr is set to the position of the first
+ *     unrecognized character. If no digit has been parsed, value of
+ *     nptr is stored there (regardless of any skipped characters at the
+ *     beginning).
+ * @param base Expected base of the string representation. If 0, base is
+ *    determined to be decimal, octal or hexadecimal using the same rules
+ *    as C syntax. Otherwise, value must be between 2 and 36, inclusive.
+ * @param min_value Lower bound for the resulting conversion.
+ * @param max_value Upper bound for the resulting conversion.
+ * @param out_negative Either NULL for unsigned conversion or a pointer to the
+ *     bool variable into which shall be placed the negativity of the resulting
+ *     converted value.
+ * @return The absolute value of the parsed value, or the closest in-range value
+ *     if the parsed value is out of range. If the input is invalid, zero is
+ *     returned and errno is set to EINVAL.
+ */
+static inline uintmax_t internal_strtol(
     const char *restrict nptr, char **restrict endptr, int base,
-    const long long min_value, const unsigned long long max_value,
+    const intmax_t min_value, const uintmax_t max_value,
     bool *restrict out_negative)
 {
@@ -78,8 +116,11 @@
 	}
 	
-	unsigned long long real_max_value = max_value;
+	/* The maximal absolute value that can be returned in this run.
+	 * Depends on sign.
+	 */
+	uintmax_t real_max_value = max_value;
 	
 	/* Current index in the input string. */
-	int i = 0;
+	size_t i = 0;
 	bool negative = false;
 	
@@ -93,5 +134,14 @@
 	case '-':
 		negative = true;
-		real_max_value = -min_value;
+		
+		/* The strange computation is are there to avoid a corner case
+		 * where -min_value can't be represented in intmax_t.
+		 * (I'm not exactly sure what the semantics are in such a
+		 *  case, but this should be safe for any case.)
+		 */
+		real_max_value = (min_value == 0)
+		    ? 0
+		    :(((uintmax_t) -(min_value + 1)) + 1);
+		
 		/* fallthrough */
 	case '+':
@@ -104,14 +154,18 @@
 		if (nptr[i] == '0') {
 			if (tolower(nptr[i + 1]) == 'x') {
+				/* 0x... is hex. */
 				base = 16;
 				i += 2;
 			} else {
+				/* 0... is octal. */
 				base = 8;
 			}
 		} else {
+			/* Anything else is decimal by default. */
 			base = 10;
 		}
 		break;
 	case 16:
+		/* Allow hex number to be prefixed with "0x". */
 		if (nptr[i] == '0' && tolower(nptr[i + 1]) == 'x') {
 			i += 2;
@@ -133,7 +187,7 @@
 	 * of overflow.
 	 */
-	unsigned long long max_safe_value = (real_max_value - base + 1) / base;
-	
-	unsigned long long result = 0;
+	uintmax_t max_safe_value = (real_max_value - base + 1) / base;
+	
+	uintmax_t result = 0;
 	
 	if (real_max_value == 0) {
@@ -145,5 +199,5 @@
 			if (nptr[i] != '0') {
 				errno = ERANGE;
-				result = max_value;
+				result = 0;
 			}
 			i++;
@@ -152,16 +206,15 @@
 	
 	while (is_digit_in_base(nptr[i], base)) {
-		int digit = get_digit_in_base(nptr[i], base);
+		int digit = digit_value(nptr[i]);
 		
 		if (result > max_safe_value) {
 			/* corner case, check for overflow */
 			
-			unsigned long long
-			    boundary = (real_max_value - digit) / base;
+			uintmax_t boundary = (real_max_value - digit) / base;
 			
 			if (result > boundary) {
 				/* overflow */
 				errno = ERANGE;
-				result = max_value;
+				result = real_max_value;
 				break;
 			}
@@ -188,54 +241,118 @@
 }
 
+/**
+ * Convert a string to an integer.
+ *
+ * @param nptr Input string.
+ * @return Result of the conversion.
+ */
 int posix_atoi(const char *nptr)
 {
 	bool neg = false;
-	unsigned long long result =
+	uintmax_t result =
 	    internal_strtol(nptr, NULL, 10, INT_MIN, INT_MAX, &neg);
 
-	return (int) (neg ? -result : result);
-}
-
+	return (neg ? ((int) -result) : (int) result);
+}
+
+/**
+ * Convert a string to a long integer.
+ *
+ * @param nptr Input string.
+ * @return Result of the conversion.
+ */
 long posix_atol(const char *nptr)
 {
 	bool neg = false;
-	unsigned long long result =
+	uintmax_t result =
 	    internal_strtol(nptr, NULL, 10, LONG_MIN, LONG_MAX, &neg);
 
-	return (long) (neg ? -result : result);
-}
-
+	return (neg ? ((long) -result) : (long) result);
+}
+
+/**
+ * Convert a string to a long long integer.
+ *
+ * @param nptr Input string.
+ * @return Result of the conversion.
+ */
 long long posix_atoll(const char *nptr)
 {
 	bool neg = false;
-	unsigned long long result =
+	uintmax_t result =
 	    internal_strtol(nptr, NULL, 10, LLONG_MIN, LLONG_MAX, &neg);
 
-	return (long long) (neg ? -result : result);
-}
-
+	return (neg ? ((long long) -result) : (long long) result);
+}
+
+/**
+ * Convert a string to a long integer.
+ *
+ * @param nptr Input string.
+ * @param endptr Pointer to the final part of the string which
+ *     was not used for conversion.
+ * @param base Expected base of the string representation.
+ * @return Result of the conversion.
+ */
 long posix_strtol(const char *restrict nptr, char **restrict endptr, int base)
 {
 	bool neg = false;
-	unsigned long long result =
+	uintmax_t result =
 	    internal_strtol(nptr, endptr, base, LONG_MIN, LONG_MAX, &neg);
 
-	return (long) (neg ? -result : result);
-}
-
+	return (neg ? ((long) -result) : ((long) result));
+}
+
+/**
+ * Convert a string to a long long integer.
+ *
+ * @param nptr Input string.
+ * @param endptr Pointer to the final part of the string which
+ *     was not used for conversion.
+ * @param base Expected base of the string representation.
+ * @return Result of the conversion.
+ */
 long long posix_strtoll(
     const char *restrict nptr, char **restrict endptr, int base)
 {
 	bool neg = false;
-	unsigned long long result =
+	uintmax_t result =
 	    internal_strtol(nptr, endptr, base, LLONG_MIN, LLONG_MAX, &neg);
 
-	return (long long) (neg ? -result : result);
-}
-
+	return (neg ? ((long long) -result) : (long long) result);
+}
+
+/**
+ * Convert a string to a largest signed integer type.
+ *
+ * @param nptr Input string.
+ * @param endptr Pointer to the final part of the string which
+ *     was not used for conversion.
+ * @param base Expected base of the string representation.
+ * @return Result of the conversion.
+ */
+intmax_t posix_strtoimax(
+    const char *restrict nptr, char **restrict endptr, int base)
+{
+	bool neg = false;
+	uintmax_t result =
+	    internal_strtol(nptr, endptr, base, INTMAX_MIN, INTMAX_MAX, &neg);
+
+	return (neg ? ((intmax_t) -result) : (intmax_t) result);
+}
+
+/**
+ * Convert a string to an unsigned long integer.
+ *
+ * @param nptr Input string.
+ * @param endptr Pointer to the final part of the string which
+ *     was not used for conversion.
+ * @param base Expected base of the string representation.
+ * @return Result of the conversion.
+ */
 unsigned long posix_strtoul(
     const char *restrict nptr, char **restrict endptr, int base)
 {
-	unsigned long long result =
+	uintmax_t result =
 	    internal_strtol(nptr, endptr, base, 0, ULONG_MAX, NULL);
 
@@ -243,12 +360,40 @@
 }
 
+/**
+ * Convert a string to an unsigned long long integer.
+ *
+ * @param nptr Input string.
+ * @param endptr Pointer to the final part of the string which
+ *     was not used for conversion.
+ * @param base Expected base of the string representation.
+ * @return Result of the conversion.
+ */
 unsigned long long posix_strtoull(
     const char *restrict nptr, char **restrict endptr, int base)
 {
-	return internal_strtol(nptr, endptr, base, 0, ULLONG_MAX, NULL);
-}
-
+	uintmax_t result =
+	    internal_strtol(nptr, endptr, base, 0, ULLONG_MAX, NULL);
+
+	return (unsigned long long) result;
+}
+
+/**
+ * Convert a string to a largest unsigned integer type.
+ *
+ * @param nptr Input string.
+ * @param endptr Pointer to the final part of the string which
+ *     was not used for conversion.
+ * @param base Expected base of the string representation.
+ * @return Result of the conversion.
+ */
+uintmax_t posix_strtoumax(
+    const char *restrict nptr, char **restrict endptr, int base)
+{
+	uintmax_t result =
+	    internal_strtol(nptr, endptr, base, 0, UINTMAX_MAX, NULL);
+
+	return result;
+}
 
 /** @}
  */
-
Index: uspace/lib/posix/stdlib/strtold.c
===================================================================
--- uspace/lib/posix/stdlib/strtold.c	(revision 5889fc748064079a47e18694d50ee1eefd0848ef)
+++ uspace/lib/posix/stdlib/strtold.c	(revision 6c69d19e1d534bd8ed18b32d34a896128d469e16)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Backend for floating point conversions.
  */
 
@@ -46,4 +46,7 @@
 #include "../strings.h"
 #include "../errno.h"
+#include "../limits.h"
+
+// FIXME: #include <float.h>
 
 #ifndef HUGE_VALL
@@ -52,49 +55,56 @@
 
 #ifndef abs
-	#define abs(x) ((x < 0) ? -x : x)
-#endif
-
-// TODO: clean up, documentation
-
-// FIXME: ensure it builds and works on all platforms
-
-const int max_small_pow5 = 15;
-
-/* The value at index i is approximately 5**i. */
-long double small_pow5[] = {
-	0x1P0,
-	0x5P0,
-	0x19P0,
-	0x7dP0,
-	0x271P0,
-	0xc35P0,
-	0x3d09P0,
-	0x1312dP0,
-	0x5f5e1P0,
-	0x1dcd65P0,
-	0x9502f9P0,
-	0x2e90eddP0,
-	0xe8d4a51P0,
-	0x48c27395P0,
-	0x16bcc41e9P0,
-	0x71afd498dP0
+	#define abs(x) (((x) < 0) ? -(x) : (x))
+#endif
+
+/* If the constants are not defined, use double precision as default. */
+#ifndef LDBL_MANT_DIG
+	#define LDBL_MANT_DIG 53
+#endif
+#ifndef LDBL_MAX_EXP
+	#define LDBL_MAX_EXP 1024
+#endif
+#ifndef LDBL_MIN_EXP
+	#define LDBL_MIN_EXP (-1021)
+#endif
+#ifndef LDBL_DIG
+	#define LDBL_DIG 15
+#endif
+#ifndef LDBL_MIN
+	#define LDBL_MIN 2.2250738585072014E-308
+#endif
+
+/* power functions ************************************************************/
+
+#if LDBL_MAX_EXP >= 16384
+const int MAX_POW5 = 12;
+#else
+const int MAX_POW5 = 8;
+#endif
+
+/* The value at index i is approximately 5**(2**i). */
+long double pow5[] = {
+	0x5p0l,
+	0x19p0l,
+	0x271p0l,
+	0x5F5E1p0l,
+	0x2386F26FC1p0l,
+	0x4EE2D6D415B85ACEF81p0l,
+	0x184F03E93FF9F4DAA797ED6E38ED6p36l,
+	0x127748F9301D319BF8CDE66D86D62p185l,
+	0x154FDD7F73BF3BD1BBB77203731FDp482l,
+#if LDBL_MAX_EXP >= 16384
+	0x1C633415D4C1D238D98CAB8A978A0p1076l,
+	0x192ECEB0D02EA182ECA1A7A51E316p2265l,
+	0x13D1676BB8A7ABBC94E9A519C6535p4643l,
+	0x188C0A40514412F3592982A7F0094p9398l,
+#endif
 };
 
-/* The value at index i is approximately 5**(2**i). */
-long double large_pow5[] = {
-	0x5P0l,
-	0x19P0l,
-	0x271P0l,
-	0x5f5e1P0l,
-	0x2386f26fc1P0l,
-	0x4ee2d6d415b85acef81P0l,
-	0x184f03e93ff9f4daa797ed6e38ed64bf6a1f01P0l,
-	0x24ee91f2603a6337f19bccdb0dac404dc08d3cff5ecP128l,
-	0x553f75fdcefcef46eeddcP512l,
-	0x1c633415d4c1d238d98cab8a978a0b1f138cb07303P1024l,
-	0x325d9d61a05d4305d9434f4a3c62d433949ae6209d492P2200l,
-	0x9e8b3b5dc53d5de4a74d28ce329ace526a3197bbebe3034f77154ce2bcba1964P4500l,
-	0x6230290145104bcd64a60a9fc025254932bb0fd922271133eeae7P9300l
-};
+#if LDBL_MAX_EXP >= 16384
+const int MAX_POW2 = 15;
+#else
+const int MAX_POW2 = 9;
+#endif
 
 /* Powers of two. */
@@ -110,41 +120,41 @@
 	0x1P256l,
 	0x1P512l,
+#if LDBL_MAX_EXP >= 16384
 	0x1P1024l,
 	0x1P2048l,
 	0x1P4096l,
-	0x1P8192l
+	0x1P8192l,
+#endif
 };
 
-static inline bool out_of_range(long double num)
-{
-	return num == 0.0l || num == HUGE_VALL;
-}
-
 /**
  * Multiplies a number by a power of five.
- * The result is not exact and may not be the best possible approximation.
- *
- * @param base Number to be multiplied.
- * @param exponent Base 5 exponent.
- * @return base multiplied by 5**exponent
- */
-static long double mul_pow5(long double base, int exponent)
-{
-	if (out_of_range(base)) {
-		return base;
-	}
-	
-	if (abs(exponent) >> 13 != 0) {
+ * The result may be inexact and may not be the best possible approximation.
+ *
+ * @param mant Number to be multiplied.
+ * @param exp Base 5 exponent.
+ * @return mant multiplied by 5**exp
+ */
+static long double mul_pow5(long double mant, int exp)
+{
+	if (mant == 0.0l || mant == HUGE_VALL) {
+		return mant;
+	}
+	
+	if (abs(exp) >> (MAX_POW5 + 1) != 0) {
+		/* Too large exponent. */
 		errno = ERANGE;
-		return exponent < 0 ? 0.0l : HUGE_VALL;
-	}
-	
-	if (exponent < 0) {
-		exponent = -exponent;
-		base /= small_pow5[exponent & 0xF];
-		for (int i = 4; i < 13; ++i) {
-			if (((exponent >> i) & 1) != 0) {
-				base /= large_pow5[i];
-				if (out_of_range(base)) {
+		return exp < 0 ? LDBL_MIN : HUGE_VALL;
+	}
+	
+	if (exp < 0) {
+		exp = abs(exp);
+		for (int bit = 0; bit <= MAX_POW5; ++bit) {
+			/* Multiply by powers of five bit-by-bit. */
+			if (((exp >> bit) & 1) != 0) {
+				mant /= pow5[bit];
+				if (mant == 0.0l) {
+					/* Underflow. */
+					mant = LDBL_MIN;
 					errno = ERANGE;
 					break;
@@ -153,9 +163,10 @@
 		}
 	} else {
-		base *= small_pow5[exponent & 0xF];
-		for (int i = 4; i < 13; ++i) {
-			if (((exponent >> i) & 1) != 0) {
-				base *= large_pow5[i];
-				if (out_of_range(base)) {
+		for (int bit = 0; bit <= MAX_POW5; ++bit) {
+			/* Multiply by powers of five bit-by-bit. */
+			if (((exp >> bit) & 1) != 0) {
+				mant *= pow5[bit];
+				if (mant == HUGE_VALL) {
+					/* Overflow. */
 					errno = ERANGE;
 					break;
@@ -165,31 +176,32 @@
 	}
 	
-	return base;
-}
-
-/**
- * Multiplies a number by a power of two.
- *
- * @param base Number to be multiplied.
- * @param exponent Base 2 exponent.
- * @return base multiplied by 2**exponent
- */
-static long double mul_pow2(long double base, int exponent)
-{
-	if (out_of_range(base)) {
-		return base;
-	}
-	
-	if (abs(exponent) >> 14 != 0) {
+	return mant;
+}
+
+/**
+ * Multiplies a number by a power of two. This is always exact.
+ *
+ * @param mant Number to be multiplied.
+ * @param exp Base 2 exponent.
+ * @return mant multiplied by 2**exp.
+ */
+static long double mul_pow2(long double mant, int exp)
+{
+	if (mant == 0.0l || mant == HUGE_VALL) {
+		return mant;
+	}
+	
+	if (exp > LDBL_MAX_EXP || exp < LDBL_MIN_EXP) {
 		errno = ERANGE;
-		return exponent < 0 ? 0.0l : HUGE_VALL;
-	}
-	
-	if (exponent < 0) {
-		exponent = -exponent;
-		for (int i = 0; i < 14; ++i) {
-			if (((exponent >> i) & 1) != 0) {
-				base /= pow2[i];
-				if (out_of_range(base)) {
+		return exp < 0 ? LDBL_MIN : HUGE_VALL;
+	}
+	
+	if (exp < 0) {
+		exp = abs(exp);
+		for (int i = 0; i <= MAX_POW2; ++i) {
+			if (((exp >> i) & 1) != 0) {
+				mant /= pow2[i];
+				if (mant == 0.0l) {
+					mant = LDBL_MIN;
 					errno = ERANGE;
 					break;
@@ -198,8 +210,8 @@
 		}
 	} else {
-		for (int i = 0; i < 14; ++i) {
-			if (((exponent >> i) & 1) != 0) {
-				base *= pow2[i];
-				if (out_of_range(base)) {
+		for (int i = 0; i <= MAX_POW2; ++i) {
+			if (((exp >> i) & 1) != 0) {
+				mant *= pow2[i];
+				if (mant == HUGE_VALL) {
 					errno = ERANGE;
 					break;
@@ -209,40 +221,49 @@
 	}
 	
-	return base;
-}
-
-
+	return mant;
+}
+
+/* end power functions ********************************************************/
+
+
+
+/**
+ * Convert decimal string representation of the floating point number.
+ * Function expects the string pointer to be already pointed at the first
+ * digit (i.e. leading optional sign was already consumed by the caller).
+ * 
+ * @param sptr Pointer to the storage of the string pointer. Upon successful
+ *     conversion, the string pointer is updated to point to the first
+ *     unrecognized character.
+ * @return An approximate representation of the input floating-point number.
+ */
 static long double parse_decimal(const char **sptr)
 {
-	// TODO: Use strtol(), at least for exponent.
+	assert(sptr != NULL);
+	assert (*sptr != NULL);
 	
 	const int DEC_BASE = 10;
 	const char DECIMAL_POINT = '.';
 	const char EXPONENT_MARK = 'e';
-	/* The highest amount of digits that can be safely parsed
-	 * before an overflow occurs.
-	 */
-	const int PARSE_DECIMAL_DIGS = 19;
-	
-	/* significand */
-	uint64_t significand = 0;
-	
-	/* position in the input string */
-	int i = 0;
+	
+	const char *str = *sptr;
+	long double significand = 0;
+	long exponent = 0;
 	
 	/* number of digits parsed so far */
 	int parsed_digits = 0;
-	
-	int exponent = 0;
-	
-	const char *str = *sptr;
-	
-	/* digits before decimal point */
-	while (isdigit(str[i])) {
-		if (parsed_digits == 0 && str[i] == '0') {
+	bool after_decimal = false;
+	
+	while (isdigit(*str) || (!after_decimal && *str == DECIMAL_POINT)) {
+		if (*str == DECIMAL_POINT) {
+			after_decimal = true;
+			str++;
+			continue;
+		}
+		
+		if (parsed_digits == 0 && *str == '0') {
 			/* Nothing, just skip leading zeros. */
-		} else if (parsed_digits < PARSE_DECIMAL_DIGS) {
-			significand *= DEC_BASE;
-			significand += str[i] - '0';
+		} else if (parsed_digits < LDBL_DIG) {
+			significand = significand * DEC_BASE + (*str - '0');
 			parsed_digits++;
 		} else {
@@ -250,69 +271,40 @@
 		}
 		
-		i++;
-	}
-	
-	if (str[i] == DECIMAL_POINT) {
-		i++;
-		
-		/* digits after decimal point */
-		while (isdigit(str[i])) {
-			if (parsed_digits == 0 && str[i] == '0') {
-				/* Skip leading zeros and decrement exponent. */
-				exponent--;
-			} else if (parsed_digits < PARSE_DECIMAL_DIGS) {
-				significand *= DEC_BASE;
-				significand += str[i] - '0';
-				exponent--;
-				parsed_digits++;
-			} else {
-				/* ignore */
-			}
-			
-			i++;
-		}
+		if (after_decimal) {
+			/* Decrement exponent if we are parsing the fractional part. */
+			exponent--;
+		}
+		
+		str++;
 	}
 	
 	/* exponent */
-	if (tolower(str[i]) == EXPONENT_MARK) {
-		i++;
-		
-		bool negative = false;
-		int exp = 0;
-		
-		switch (str[i]) {
-		case '-':
-			negative = true;
-			/* fallthrough */
-		case '+':
-			i++;
-		}
-		
-		while (isdigit(str[i])) {
-			if (exp < 65536) {
-				exp *= DEC_BASE;
-				exp += str[i] - '0';
-			}
-			
-			i++;
-		}
-		
-		if (negative) {
-			exp = -exp;
-		}
-		
-		exponent += exp;
-	}
-	
-	long double result = (long double) significand;
-	result = mul_pow5(result, exponent);
-	if (result != HUGE_VALL) {
-		result = mul_pow2(result, exponent);
-	}
-	
-	*sptr = &str[i];
-	return result;
-}
-
+	if (tolower(*str) == EXPONENT_MARK) {
+		str++;
+		
+		/* Returns MIN/MAX value on error, which is ok. */
+		long exp = strtol(str, (char **) &str, DEC_BASE);
+		
+		if (exponent > 0 && exp > LONG_MAX - exponent) {
+			exponent = LONG_MAX;
+		} else if (exponent < 0 && exp < LONG_MIN - exponent) {
+			exponent = LONG_MIN;
+		} else {
+			exponent += exp;
+		}
+	}
+	
+	*sptr = str;
+	
+	/* Return multiplied by a power of ten. */
+	return mul_pow2(mul_pow5(significand, exponent), exponent);
+}
+
+/**
+ * Derive a hexadecimal digit from its character representation.
+ * 
+ * @param ch Character representation of the hexadecimal digit.
+ * @return Digit value represented by an integer.
+ */
 static inline int hex_value(char ch)
 {
@@ -325,24 +317,17 @@
 
 /**
- * @param val Integer value.
- * @return How many leading zero bits there are. (Maximum is 3)
- */
-static inline int leading_zeros(uint64_t val)
-{
-	for (int i = 3; i > 0; --i) {
-		if ((val >> (64 - i)) == 0) {
-			return i;
-		}
-	}
-	
-	return 0;
-}
-
+ * Convert hexadecimal string representation of the floating point number.
+ * Function expects the string pointer to be already pointed at the first
+ * digit (i.e. leading optional sign and 0x prefix were already consumed
+ * by the caller).
+ *
+ * @param sptr Pointer to the storage of the string pointer. Upon successful
+ *     conversion, the string pointer is updated to point to the first
+ *     unrecognized character.
+ * @return Representation of the input floating-point number.
+ */
 static long double parse_hexadecimal(const char **sptr)
 {
-	// TODO: Use strtol(), at least for exponent.
-	
-	/* this function currently always rounds to zero */
-	// TODO: honor rounding mode
+	assert(sptr != NULL && *sptr != NULL);
 	
 	const int DEC_BASE = 10;
@@ -350,118 +335,56 @@
 	const char DECIMAL_POINT = '.';
 	const char EXPONENT_MARK = 'p';
-	/* The highest amount of digits that can be safely parsed
-	 * before an overflow occurs.
-	 */
-	const int PARSE_HEX_DIGS = 16;
-	
-	/* significand */
-	uint64_t significand = 0;
-	
-	/* position in the input string */
-	int i = 0;
-	
-	/* number of digits parsed so far */
-	int parsed_digits = 0;
-	
-	int exponent = 0;
 	
 	const char *str = *sptr;
-	
-	/* digits before decimal point */
-	while (posix_isxdigit(str[i])) {
-		if (parsed_digits == 0 && str[i] == '0') {
+	long double significand = 0;
+	long exponent = 0;
+	
+	/* number of bits parsed so far */
+	int parsed_bits = 0;
+	bool after_decimal = false;
+	
+	while (posix_isxdigit(*str) || (!after_decimal && *str == DECIMAL_POINT)) {
+		if (*str == DECIMAL_POINT) {
+			after_decimal = true;
+			str++;
+			continue;
+		}
+		
+		if (parsed_bits == 0 && *str == '0') {
 			/* Nothing, just skip leading zeros. */
-		} else if (parsed_digits < PARSE_HEX_DIGS) {
-			significand *= HEX_BASE;
-			significand += hex_value(str[i]);
-			parsed_digits++;
-		} else if (parsed_digits == PARSE_HEX_DIGS) {
-			/* The first digit may have had leading zeros,
-			 * so we need to parse one more digit and shift
-			 * the value accordingly.
-			 */
-			
-			int zeros = leading_zeros(significand);
-			significand = (significand << zeros) |
-			    (hex_value(str[i]) >> (4 - zeros));
-			
-			exponent += (4 - zeros);
-			parsed_digits++;
+		} else if (parsed_bits <= LDBL_MANT_DIG) {
+			significand = significand * HEX_BASE + hex_value(*str);
+			parsed_bits += 4;
 		} else {
 			exponent += 4;
 		}
 		
-		i++;
-	}
-	
-	if (str[i] == DECIMAL_POINT) {
-		i++;
-		
-		/* digits after decimal point */
-		while (posix_isxdigit(str[i])) {
-			if (parsed_digits == 0 && str[i] == '0') {
-				/* Skip leading zeros and decrement exponent. */
-				exponent -= 4;
-			} else if (parsed_digits < PARSE_HEX_DIGS) {
-				significand *= HEX_BASE;
-				significand += hex_value(str[i]);
-				exponent -= 4;
-				parsed_digits++;
-			} else if (parsed_digits == PARSE_HEX_DIGS) {
-				/* The first digit may have had leading zeros,
-				 * so we need to parse one more digit and shift
-				 * the value accordingly.
-				 */
-				
-				int zeros = leading_zeros(significand);
-				significand = (significand << zeros) |
-				    (hex_value(str[i]) >> (4 - zeros));
-				
-				exponent -= zeros;
-				parsed_digits++;
-			} else {
-				/* ignore */
-			}
-			
-			i++;
-		}
+		if (after_decimal) {
+			exponent -= 4;
+		}
+		
+		str++;
 	}
 	
 	/* exponent */
-	if (tolower(str[i]) == EXPONENT_MARK) {
-		i++;
-		
-		bool negative = false;
-		int exp = 0;
-		
-		switch (str[i]) {
-		case '-':
-			negative = true;
-			/* fallthrough */
-		case '+':
-			i++;
-		}
-		
-		while (isdigit(str[i])) {
-			if (exp < 65536) {
-				exp *= DEC_BASE;
-				exp += str[i] - '0';
-			}
-			
-			i++;
-		}
-		
-		if (negative) {
-			exp = -exp;
-		}
-		
-		exponent += exp;
-	}
-	
-	long double result = (long double) significand;
-	result = mul_pow2(result, exponent);
-	
-	*sptr = &str[i];
-	return result;
+	if (tolower(*str) == EXPONENT_MARK) {
+		str++;
+		
+		/* Returns MIN/MAX value on error, which is ok. */
+		long exp = strtol(str, (char **) &str, DEC_BASE);
+		
+		if (exponent > 0 && exp > LONG_MAX - exponent) {
+			exponent = LONG_MAX;
+		} else if (exponent < 0 && exp < LONG_MIN - exponent) {
+			exponent = LONG_MIN;
+		} else {
+			exponent += exp;
+		}
+	}
+	
+	*sptr = str;
+	
+	/* Return multiplied by a power of two. */
+	return mul_pow2(significand, exponent);
 }
 
@@ -478,5 +401,5 @@
  * @param nptr Input string.
  * @param endptr If non-NULL, *endptr is set to the position of the first
- *    unrecognized character.
+ *     unrecognized character.
  * @return An approximate representation of the input floating-point number.
  */
@@ -512,8 +435,8 @@
 		
 		if (endptr != NULL) {
-			*endptr = (char *) &nptr[i + 3];
-		}
-		errno = ERANGE;
-		return negative ? -0.0l : +0.0l;
+			*endptr = (char *) nptr;
+		}
+		errno = EINVAL;
+		return 0;
 	}
 	
@@ -567,3 +490,2 @@
 /** @}
  */
-
